# -*-coding:utf-8 -*
import json

from lib_Partage_BSS import utils
from lib_Partage_BSS.exceptions.NameException import NameException
from lib_Partage_BSS.models.GlobalModel import GlobalModel


class COS(GlobalModel):
    """
    Classe représentant une classe de service dans Partage

    :ivar _zimbraDumpsterEnabled: ...
    :ivar _zimbraExternalSharingEnabled: ...
    :ivar _zimbraFeatureBriefcasesEnabled: ...
    :ivar _zimbraFeatureCalendarEnabled: ...
    :ivar _zimbraFeatureChangePasswordEnabled: ...
    :ivar _zimbraFeatureContactsEnabled: ...
    :ivar _zimbraFeatureConversationsEnabled: ...
    :ivar _zimbraFeatureDistributionListFolderEnabled: ...
    :ivar _zimbraFeatureExportFolderEnabled: ...
    :ivar _zimbraFeatureFiltersEnabled: ...
    :ivar _zimbraFeatureFlaggingEnabled: ...
    :ivar _zimbraFeatureGalAutoCompleteEnabled: ...
    :ivar _zimbraFeatureGalEnabled: ...
    :ivar _zimbraFeatureGroupCalendarEnabled: ...
    :ivar _zimbraFeatureHtmlComposeEnabled: ...
    :ivar _zimbraFeatureIdentitiesEnabled: ...
    :ivar _zimbraFeatureImapDataSourceEnabled: ...
    :ivar _zimbraFeatureImportFolderEnabled: ...
    :ivar _zimbraFeatureMailEnabled: ...
    :ivar _zimbraFeatureMailForwardingEnabled: ...
    :ivar _zimbraFeatureMailPriorityEnabled: ...
    :ivar _zimbraFeatureMailSendLaterEnabled: ...
    :ivar _zimbraFeatureManageZimlets: ...
    :ivar _zimbraFeatureMAPIConnectorEnabled: ...
    :ivar _zimbraFeatureMobileSyncEnabled: ...
    :ivar _zimbraFeatureNewMailNotificationEnabled: ...
    :ivar _zimbraFeatureOptionsEnabled: ...
    :ivar _zimbraFeatureOutOfOfficeReplyEnabled: ...
    :ivar _zimbraFeaturePop3DataSourceEnabled: ...
    :ivar _zimbraFeatureReadReceiptsEnabled: ...
    :ivar _zimbraFeatureSavedSearchesEnabled: ...
    :ivar _zimbraFeatureSharingEnabled: ...
    :ivar _zimbraFeatureSkinChangeEnabled: ...
    :ivar _zimbraFeatureTaggingEnabled: ...
    :ivar _zimbraFeatureTasksEnabled: ...
    :ivar _zimbraId: identifiant de la classe de service
    :ivar _zimbraImapEnabled: ...
    :ivar _zimbraMailQuota: quota de la classe de service
    :ivar _zimbraNotes: commentaire
    :ivar _zimbraPop3Enabled: ...
    :ivar _zimbraPublicSharingEnabled: ...
    :ivar _zimbraZimletAvailableZimlets: Array ...
    """
    def __init__(self, name):
        GlobalModel.__init__(self, name)
        for attr in ['zimbraDumpsterEnabled','zimbraExternalSharingEnabled','zimbraFeatureCalendarEnabled','zimbraFeatureChangePasswordEnabled',
                     'zimbraFeatureContactsEnabled','zimbraFeatureConversationsEnabled','zimbraFeatureDistributionListFolderEnabled',
                     'zimbraFeatureExportFolderEnabled','zimbraFeatureFiltersEnabled','zimbraFeatureFlaggingEnabled','zimbraFeatureGalAutoCompleteEnabled',
                     'zimbraFeatureGalEnabled','zimbraFeatureGroupCalendarEnabled','zimbraFeatureHtmlComposeEnabled','zimbraFeatureIdentitiesEnabled',
                     'zimbraFeatureImapDataSourceEnabled','zimbraFeatureImportFolderEnabled','zimbraFeatureMailEnabled','zimbraFeatureMailForwardingEnabled',
                     'zimbraFeatureMailPriorityEnabled','zimbraFeatureMailSendLaterEnabled','zimbraFeatureManageZimlets','zimbraFeatureMAPIConnectorEnabled',
                     'zimbraFeatureMobileSyncEnabled','zimbraFeatureNewMailNotificationEnabled','zimbraFeatureOptionsEnabled','zimbraFeatureOutOfOfficeReplyEnabled',
                     'zimbraFeaturePop3DataSourceEnabled','zimbraFeatureReadReceiptsEnabled','zimbraFeatureSavedSearchesEnabled','zimbraFeatureSharingEnabled',
                     'zimbraFeatureSkinChangeEnabled','zimbraFeatureTaggingEnabled','zimbraFeatureTasksEnabled','zimbraId','zimbraImapEnabled','_zimbraMailQuota',
                     'zimbraNotes','zimbraPop3Enabled','zimbraPublicSharingEnabled','zimbraZimletAvailableZimlets']:
            setattr(self, attr, None)

    def fillCOS(self, listOfAttr):
        if not isinstance(listOfAttr, dict):
            raise TypeError

        for key, value in listOfAttr.items():
            setattr(self, key, value)



